#include "lrclib.h"

#define lrc_dummy_term C_Int(0)
#define lrc_nil_ptr lrc_dummy_term

#include "bcode.ttm"
#include "bcode.htc"

#include "bcode.hff"
#include "bcode.hsf"

#if VISUAL==2
#include "bcode.ebh"
#endif

/* jas */

#include "bcode.isf"

#ifdef TRANSFORM
#define LRC_DEFINE_TRANSFORMATION(nt,tr_name,tr_number) \
lrc_define_transformation(#nt,tr_name, lrc_matches_ ## tr_number, lrc_transform_ ## tr_number);

void lrc_define_transformations() {
#include "bcode.tfd"
}
#endif



#if VISUAL==2

#define _lrc_nth_pb_elem(n) _lrc_nth_list_elem(n,_parameters)

static lrc_term _lrc_nth_list_elem(int n, lrc_term parameters) {
  while (n>0) { n=n-1; parameters=LRC_CHILD(parameters,2); }
  return LRC_CHILD(parameters,1);
}

#include "bcode.ebf"
#endif
