#define WORD_IS_INT
#define BYTES_IN_INT 4
#define BYTES_IN_SHORT 2

#ifdef WORD_IS_CHAR
#  define WORD char
#  define BIW 8
#  define LOG_BIW 3
#endif

#ifdef WORD_IS_SHORT
#  define WORD short
#  define BIW (8*BYTES_IN_SHORT)
#  define LOG_BIW 4
#endif

#ifdef WORD_IS_INT
#  define WORD int
#  define BIW (8*BYTES_IN_INT)
#  define LOG_BIW 5
#endif

typedef
struct
  { int width, height, wSize, bSize, raster ;
    unsigned WORD *map0 ;
  } form ;

extern void initForms(), exitForms() ;
extern form *newForm() ;
extern int widthOfForm();
extern int heightOfForm();
extern void rmForm() ;
extern int cmpForms() ;
extern void setPixel(), showForm() ;
extern int getPixel() ;
extern void copyForm(), setForm(), moveForm(), tcForm() ;
extern int tstForm() ;
