#ifdef DEBUG
#  define Assert(c,s) if(!(c)) { printf("Assertion error %s\n",s); exit(1); }
#  define AssertI(c,s,i) if(!(c)) { printf("Assertion error %s %d\n",s,i); exit(1); }
#  define DebugStatement(s) s;
#  define DebugDeclaration(d) d;
#else
#  define Assert(c,s) 
#  define AssertI(c,s,i)
#  define DebugStatement(s)
#  define DebugDeclaration(d)
#endif

