#ifndef POSITION_H
#define POSITION_H

typedef struct position {
  int row,col;
} Position;

typedef struct range {
  Position start,end;
} Range;

int p_smaller(Position,Position);
#define p_equal(p1,p2) ((p1.row==p2.row)&&(p1.col==p2.col))
#define p_is_legal(p) (p.row>=1 && p.col>=0)

#define pos_eq(p1,p2)   p_equal(p1,p2)
#define pos_less(p1,p2) ((p1.row < p2.row) || (p1.row==p2.row && p1.col < p2.col))
#define pos_leq(p1,p2)  (pos_less(p1,p2) || pos_eq(p1,p2))
#define pos_gt(p1,p2)   ((p1.row > p2.row) || (p1.row==p2.row && p1.col > p2.col))
#define pos_geq(p1,p2)  (pos_gt(p1,p2) || pos_eq(p1,p2))


#define END 999999

#endif
