void lrc_alloc_visit_table(int num_vprs, int num_vnts);
void lrc_define_visit(void f(), int global_number, int prod_number, int vis_number,
      int num_ip_attrs, int num_op_attrs);
void lrc_define_nont_visit(
  void vnt_routine(), int global_number,
  int nont_number, int visit_number, int num_ip, int num_op);

void lrc_define_packet_attr(
  int nont_number, int vis_num, char * attr_name, int packet_index, int is_input
);

char * lrc_attr_get_ip_name (int nt_num, int vnum, int packet_index);
char * lrc_attr_get_op_name (int nt_num, int vnum, int packet_index);
int    lrc_attr_get_ip_index(int nt_num, int vnum, char * attr_name);
int    lrc_attr_get_op_index(int nt_num, int vnum, char * attr_name);

int lrc_vpr_index(lrc_ptr f);

int lrc_prod_visnum_vpr_num(int prod, int vis_num);
lrc_ptr lrc_vpr_routine(int vpr_number);
int lrc_vpr_prod_number(int vpr_number);
int lrc_vpr_visit_number(int vpr_number);
int lrc_vpr_num_ip_attrs(int vpr_number);
int lrc_vpr_num_op_attrs(int vpr_number);

int lrc_prod_vnum_ip_size(int tag, int visit_number);
int lrc_prod_vnum_op_size(int tag, int visit_number);

int lrc_nont_visnum_vnt_num(int nont, int vis_num);
lrc_ptr lrc_vnt_routine(int vnt_number);
int lrc_vnt_nont_number(int vnt_number);
int lrc_vnt_visit_number(int vnt_number);
int lrc_vnt_num_ip_attrs(int vnt_number);
int lrc_vnt_num_op_attrs(int vnt_number);

lrc_term * lrc_create_ip(lrc_term t, int vnum);
lrc_term * lrc_create_op(lrc_term t, int vnum);

int lrc_visit_size(lrc_term t, int visit_number, int *ip_size, int *op_size);
lrc_term * lrc_visit_term_1(lrc_term t);
lrc_term * lrc_visit_term_with_attr_1(lrc_term t, lrc_term attr);
lrc_term * lrc_visit_term_with_attrs_1(lrc_term t, ...);

int lrc_visit_with_packets(int vis_num, lrc_term *ip, lrc_term *op);
lrc_term * lrc_visit_edse_root(lrc_term t,lrc_term bindings);

void set_packet_printing(void);
void unset_packet_printing(void);

void lrc_block_copy(lrc_term * dst, int d_offset, lrc_term *src, int s_offset, int num_terms);

