#define ADMIN_SIZE      6
#define CELL_SIZE(s)    (ADMIN_SIZE*sizeof(lrc_ptr)+(s))
#define ADMIN(t,n,tp)   (*(((tp*)(t))+(n)))
#define SIZE(t)         ADMIN(t,ADMIN_SIZE-1,int)

#define SHADOW(t)       ADMIN(t,ADMIN_SIZE-4,lrc_ptr)
#define BITS(t)         ADMIN(t,ADMIN_SIZE-5,int)
#define PARENT(t)       ADMIN(t,ADMIN_SIZE-6,lrc_ptr)

#define TERM_NULL       ((lrc_term)0)

lrc_term  lrc_create_initial(lrc_term term);
lrc_term  lrc_initial_parent(lrc_term term);
lrc_term  lrc_initial_root(lrc_term term);
lrc_term  lrc_initial_shadow(lrc_term term);
lrc_bool  lrc_is_initial(lrc_term term);
lrc_term  lrc_replace_initial(lrc_term operand,lrc_term replacement);
int       lrc_is_primitive(lrc_term);

lrc_term_ix  lrc_initial_index_parent(lrc_term term);
lrc_term     lrc_shadow(lrc_term term);

lrc_term initial_replace_child(lrc_term tree, int child_num, lrc_term replacement);
lrc_term shadow_replace_child(lrc_term tree, int child_num, lrc_term replacement);


