#ifndef H_SURGERY
#define H_SURGERY
typedef struct replacement_descriptions {
  lrc_term    term;
  int         num_repl;
  Reference * operands;
  lrc_term  * replacements;
} * Replacement;

Replacement create_replacement(lrc_term t, int num_repl);

lrc_term multi_replace(
  lrc_term ast, int num_repl, Reference * operands, lrc_term * replacements);

lrc_term in_situ_replace(lrc_term t, Path path, lrc_term replacement);
lrc_term in_situ_multi_replace(
  lrc_term ast,
  Replacement replacement
);


#endif

